/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.bodydate;

import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceException;
import com.microsoft.rest.ServiceResponse;
import com.squareup.okhttp.ResponseBody;
import org.joda.time.LocalDate;
import retrofit.Call;
import retrofit.http.Body;
import retrofit.http.GET;
import retrofit.http.PUT;

/**
 * An instance of this class provides access to all the operations defined
 * in DateOperations.
 */
public interface DateOperations {
    /**
     * The interface defining all the services for DateOperations to be
     * used by Retrofit to perform actually REST calls.
     */
    interface DateService {
        @GET("/date/null")
        Call<ResponseBody> getNull();

        @GET("/date/invaliddate")
        Call<ResponseBody> getInvalidDate();

        @GET("/date/overflowdate")
        Call<ResponseBody> getOverflowDate();

        @GET("/date/underflowdate")
        Call<ResponseBody> getUnderflowDate();

        @PUT("/date/max")
        Call<ResponseBody> putMaxDate(@Body LocalDate dateBody);

        @GET("/date/max")
        Call<ResponseBody> getMaxDate();

        @PUT("/date/min")
        Call<ResponseBody> putMinDate(@Body LocalDate dateBody);

        @GET("/date/min")
        Call<ResponseBody> getMinDate();

    }
    /**
     * Get null date value
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getNull() throws ServiceException;

    /**
     * Get null date value
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getNullAsync(final ServiceCallback<LocalDate> serviceCallback);

    /**
     * Get invalid date value
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getInvalidDate() throws ServiceException;

    /**
     * Get invalid date value
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getInvalidDateAsync(final ServiceCallback<LocalDate> serviceCallback);

    /**
     * Get overflow date value
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getOverflowDate() throws ServiceException;

    /**
     * Get overflow date value
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getOverflowDateAsync(final ServiceCallback<LocalDate> serviceCallback);

    /**
     * Get underflow date value
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getUnderflowDate() throws ServiceException;

    /**
     * Get underflow date value
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getUnderflowDateAsync(final ServiceCallback<LocalDate> serviceCallback);

    /**
     * Put max date value 9999-12-31
     *
     * @param dateBody the LocalDate value
     * @return the {@link ServiceResponse} object if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<Void> putMaxDate(LocalDate dateBody) throws ServiceException;

    /**
     * Put max date value 9999-12-31
     *
     * @param dateBody the LocalDate value
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> putMaxDateAsync(LocalDate dateBody, final ServiceCallback<Void> serviceCallback);

    /**
     * Get max date value 9999-12-31
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getMaxDate() throws ServiceException;

    /**
     * Get max date value 9999-12-31
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getMaxDateAsync(final ServiceCallback<LocalDate> serviceCallback);

    /**
     * Put min date value 0000-01-01
     *
     * @param dateBody the LocalDate value
     * @return the {@link ServiceResponse} object if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<Void> putMinDate(LocalDate dateBody) throws ServiceException;

    /**
     * Put min date value 0000-01-01
     *
     * @param dateBody the LocalDate value
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> putMinDateAsync(LocalDate dateBody, final ServiceCallback<Void> serviceCallback);

    /**
     * Get min date value 0000-01-01
     *
     * @return the LocalDate object wrapped in {@link ServiceResponse} if successful.
     * @throws ServiceException the exception wrapped in ServiceException if failed.
     */
    ServiceResponse<LocalDate> getMinDate() throws ServiceException;

    /**
     * Get min date value 0000-01-01
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link Call} object
     */
    Call<ResponseBody> getMinDateAsync(final ServiceCallback<LocalDate> serviceCallback);

}
