/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * XMsClientRequestId
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface XMsClientRequestId {

    /**
     * Get method that overwrites x-ms-client-request header with value
     * 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get(options: RequestOptions, callback: ServiceCallback<void>): void;
    get(callback: ServiceCallback<void>): void;

    /**
     * Get method that overwrites x-ms-client-request header with value
     * 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0.
     *
     * @param {string} xMsClientRequestId This should appear as a method
     * parameter, use value '9C4D50EE-2D56-4CD3-8152-34347DC9F2B0'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    paramGet(xMsClientRequestId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    paramGet(xMsClientRequestId: string, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * SubscriptionInCredentials
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface SubscriptionInCredentials {

    /**
     * POST method with subscriptionId modeled in credentials.  Set the credential
     * subscriptionId to '1234-5678-9012-3456' to succeed
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMethodGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    postMethodGlobalValid(callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in credentials.  Set the credential
     * subscriptionId to null, and client-side validation should prevent you from
     * making this call
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMethodGlobalNull(options: RequestOptions, callback: ServiceCallback<void>): void;
    postMethodGlobalNull(callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in credentials.  Set the credential
     * subscriptionId to '1234-5678-9012-3456' to succeed
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMethodGlobalNotProvidedValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    postMethodGlobalNotProvidedValid(callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in credentials.  Set the credential
     * subscriptionId to '1234-5678-9012-3456' to succeed
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postPathGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    postPathGlobalValid(callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in credentials.  Set the credential
     * subscriptionId to '1234-5678-9012-3456' to succeed
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postSwaggerGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    postSwaggerGlobalValid(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * SubscriptionInMethod
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface SubscriptionInMethod {

    /**
     * POST method with subscriptionId modeled in the method.  pass in
     * subscription id = '1234-5678-9012-3456' to succeed
     *
     * @param {string} subscriptionId This should appear as a method parameter,
     * use value '1234-5678-9012-3456'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMethodLocalValid(subscriptionId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postMethodLocalValid(subscriptionId: string, callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in the method.  pass in
     * subscription id = null, client-side validation should prevent you from
     * making this call
     *
     * @param {string} subscriptionId This should appear as a method parameter,
     * use value null, client-side validation should prvenet the call
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postMethodLocalNull(subscriptionId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postMethodLocalNull(subscriptionId: string, callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in the method.  pass in
     * subscription id = '1234-5678-9012-3456' to succeed
     *
     * @param {string} subscriptionId Should appear as a method parameter -use
     * value '1234-5678-9012-3456'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postPathLocalValid(subscriptionId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postPathLocalValid(subscriptionId: string, callback: ServiceCallback<void>): void;

    /**
     * POST method with subscriptionId modeled in the method.  pass in
     * subscription id = '1234-5678-9012-3456' to succeed
     *
     * @param {string} subscriptionId The subscriptionId, which appears in the
     * path, the value is always '1234-5678-9012-3456'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postSwaggerLocalValid(subscriptionId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postSwaggerLocalValid(subscriptionId: string, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * ApiVersionDefault
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface ApiVersionDefault {

    /**
     * GET method with api-version modeled in global settings.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodGlobalValid(callback: ServiceCallback<void>): void;

    /**
     * GET method with api-version modeled in global settings.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodGlobalNotProvidedValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodGlobalNotProvidedValid(callback: ServiceCallback<void>): void;

    /**
     * GET method with api-version modeled in global settings.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getPathGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    getPathGlobalValid(callback: ServiceCallback<void>): void;

    /**
     * GET method with api-version modeled in global settings.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getSwaggerGlobalValid(options: RequestOptions, callback: ServiceCallback<void>): void;
    getSwaggerGlobalValid(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * ApiVersionLocal
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface ApiVersionLocal {

    /**
     * Get method with api-version modeled in the method.  pass in api-version =
     * '2.0' to succeed
     *
     * @param {string} apiVersion This should appear as a method parameter, use
     * value '2.0'. Possible values for this parameter include: '2.0'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodLocalValid(apiVersion: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodLocalValid(apiVersion: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with api-version modeled in the method.  pass in api-version =
     * null to succeed
     *
     * @param {string} [apiVersion] This should appear as a method parameter, use
     * value null, this should result in no serialized parameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodLocalNull(apiVersion: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodLocalNull(apiVersion: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with api-version modeled in the method.  pass in api-version =
     * '2.0' to succeed
     *
     * @param {string} apiVersion This should appear as a method parameter, use
     * value '2.0'. Possible values for this parameter include: '2.0'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getPathLocalValid(apiVersion: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getPathLocalValid(apiVersion: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with api-version modeled in the method.  pass in api-version =
     * '2.0' to succeed
     *
     * @param {string} apiVersion The api version, which appears in the query, the
     * value is always '2.0'. Possible values for this parameter include: '2.0'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getSwaggerLocalValid(apiVersion: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getSwaggerLocalValid(apiVersion: string, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * SkipUrlEncoding
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface SkipUrlEncoding {

    /**
     * Get method with unencoded path parameter with value 'path1/path2/path3'
     *
     * @param {string} unencodedPathParam Unencoded path parameter with value
     * 'path1/path2/path3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodPathValid(unencodedPathParam: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodPathValid(unencodedPathParam: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded path parameter with value 'path1/path2/path3'
     *
     * @param {string} unencodedPathParam Unencoded path parameter with value
     * 'path1/path2/path3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getPathPathValid(unencodedPathParam: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getPathPathValid(unencodedPathParam: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded path parameter with value 'path1/path2/path3'
     *
     * @param {string} unencodedPathParam An unencoded path parameter with value
     * 'path1/path2/path3'. Possible values for this parameter include:
     * 'path1/path2/path3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getSwaggerPathValid(unencodedPathParam: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getSwaggerPathValid(unencodedPathParam: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'
     *
     * @param {string} q1 Unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodQueryValid(q1: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodQueryValid(q1: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded query parameter with value null
     *
     * @param {string} [q1] Unencoded query parameter with value null
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getMethodQueryNull(q1: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getMethodQueryNull(q1: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'
     *
     * @param {string} q1 Unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getPathQueryValid(q1: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getPathQueryValid(q1: string, callback: ServiceCallback<void>): void;

    /**
     * Get method with unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'
     *
     * @param {string} [q1] An unencoded query parameter with value
     * 'value1&q2=value2&q3=value3'. Possible values for this parameter include:
     * 'value1&q2=value2&q3=value3'
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getSwaggerQueryValid(q1: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    getSwaggerQueryValid(q1: string, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * Header
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestAzureSpecialParametersTestClient.
 */
export interface Header {

    /**
     * Send foo-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 in the
     * header of the request
     *
     * @param {string} fooClientRequestId The fooRequestId
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    customNamedRequestId(fooClientRequestId: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    customNamedRequestId(fooClientRequestId: string, callback: ServiceCallback<void>): void;
}
