/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the OperationResult class.
 * @constructor
 * @member {string} [status] The status of the request. Possible values for
 * this property include: 'Succeeded', 'Failed', 'canceled', 'Accepted',
 * 'Creating', 'Created', 'Updating', 'Updated', 'Deleting', 'Deleted', 'OK'.
 * 
 */
function OperationResult(parameters) {
  if (parameters !== null && parameters !== undefined) {
    if (parameters.status !== undefined) {
      this.status = parameters.status;
    }
  }    
}


/**
 * Validate the payload against the OperationResult schema
 *
 * @param {JSON} payload
 *
 */
OperationResult.prototype.serialize = function () {
  var payload = {};
  if (this['status'] !== null && this['status'] !== undefined) {
    if (typeof this['status'].valueOf() !== 'string') {
      throw new Error('this[\'status\'] must be of type string.');
    }
    payload['status'] = this['status'];
  }

  return payload;
};

/**
 * Deserialize the instance to OperationResult schema
 *
 * @param {JSON} instance
 *
 */
OperationResult.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance['status'] !== undefined) {
      this['status'] = instance['status'];
    }
  }

  return this;
};

module.exports = OperationResult;
