/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the Cat class.
 * @constructor
 * @member {string} [color]
 * 
 * @member {array} [hates]
 * 
 */
function Cat(parameters) {
  Cat['super_'].call(this, parameters);
  if (parameters !== null && parameters !== undefined) {
    if (parameters.color !== undefined) {
      this.color = parameters.color;
    }
    if (parameters.hates) {
      var tempParametershates = [];
      parameters.hates.forEach(function(element) {
        if (element) {
          element = new models['Dog'](element);
        }
        tempParametershates.push(element);
      });
      this.hates = tempParametershates;
    }
  }    
}

util.inherits(Cat, models['Pet']);

/**
 * Validate the payload against the Cat schema
 *
 * @param {JSON} payload
 *
 */
Cat.prototype.serialize = function () {
  var payload = Cat['super_'].prototype.serialize.call(this);
  if (this['color'] !== null && this['color'] !== undefined) {
    if (typeof this['color'].valueOf() !== 'string') {
      throw new Error('this[\'color\'] must be of type string.');
    }
    payload['color'] = this['color'];
  }

  if (util.isArray(this['hates'])) {
    payload['hates'] = [];
    for (var i = 0; i < this['hates'].length; i++) {
      if (this['hates'][i]) {
        if (payload['hates'] === null || payload['hates'] === undefined) {
          payload['hates'] = {};
        }
        payload['hates'][i] = this['hates'][i].serialize();
      }
    }
  }

  return payload;
};

/**
 * Deserialize the instance to Cat schema
 *
 * @param {JSON} instance
 *
 */
Cat.prototype.deserialize = function (instance) {
  Cat['super_'].prototype.deserialize.call(this, instance);
  if (instance) {
    if (instance['color'] !== undefined) {
      this['color'] = instance['color'];
    }

    if (instance['hates']) {
      var tempInstancehates = [];
      instance['hates'].forEach(function(element1) {
        if (element1) {
          element1 = new models['Dog']().deserialize(element1);
        }
        tempInstancehates.push(element1);
      });
      this['hates'] = tempInstancehates;
    }
  }

  return this;
};

module.exports = Cat;
