/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * Implicit
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestRequiredOptionalTestService.
 */
export interface Implicit {

    /**
     * Test implicitly required path parameter
     *
     * @param {string} pathParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getRequiredPath(pathParameter: string, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    getRequiredPath(pathParameter: string, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test implicitly optional query parameter
     *
     * @param {string} [queryParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putOptionalQuery(queryParameter: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    putOptionalQuery(queryParameter: string, callback: ServiceCallback<void>): void;

    /**
     * Test implicitly optional header parameter
     *
     * @param {string} [queryParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putOptionalHeader(queryParameter: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    putOptionalHeader(queryParameter: string, callback: ServiceCallback<void>): void;

    /**
     * Test implicitly optional body parameter
     *
     * @param {string} [bodyParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putOptionalBody(bodyParameter: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    putOptionalBody(bodyParameter: string, callback: ServiceCallback<void>): void;

    /**
     * Test implicitly required path parameter
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getRequiredGlobalPath(options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    getRequiredGlobalPath(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test implicitly required query parameter
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getRequiredGlobalQuery(options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    getRequiredGlobalQuery(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test implicitly optional query parameter
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getOptionalGlobalQuery(options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    getOptionalGlobalQuery(callback: ServiceCallback<models.ErrorModel>): void;
}

/**
 * @class
 * Explicit
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestRequiredOptionalTestService.
 */
export interface Explicit {

    /**
     * Test explicitly required integer. Please put null and the client library
     * should throw before the request is sent.
     *
     * @param {number} bodyParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredIntegerParameter(bodyParameter: number, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredIntegerParameter(bodyParameter: number, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional integer. Please put null.
     *
     * @param {number} [bodyParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalIntegerParameter(bodyParameter: number, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalIntegerParameter(bodyParameter: number, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required integer. Please put a valid int-wrapper with
     * 'value' = null and the client library should throw before the request is
     * sent.
     *
     * @param {number} value
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredIntegerProperty(value: number, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredIntegerProperty(value: number, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional integer. Please put a valid int-wrapper with
     * 'value' = null.
     *
     * @param {number} [value]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalIntegerProperty(value: number, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalIntegerProperty(value: number, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required integer. Please put a header 'headerParameter' =>
     * null and the client library should throw before the request is sent.
     *
     * @param {number} headerParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredIntegerHeader(headerParameter: number, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredIntegerHeader(headerParameter: number, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional integer. Please put a header 'headerParameter' =>
     * null.
     *
     * @param {number} [headerParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalIntegerHeader(headerParameter: number, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalIntegerHeader(headerParameter: number, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required string. Please put null and the client library
     * should throw before the request is sent.
     *
     * @param {string} bodyParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredStringParameter(bodyParameter: string, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredStringParameter(bodyParameter: string, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional string. Please put null.
     *
     * @param {string} [bodyParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalStringParameter(bodyParameter: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalStringParameter(bodyParameter: string, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required string. Please put a valid string-wrapper with
     * 'value' = null and the client library should throw before the request is
     * sent.
     *
     * @param {string} value
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredStringProperty(value: string, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredStringProperty(value: string, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional integer. Please put a valid string-wrapper with
     * 'value' = null.
     *
     * @param {string} [value]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalStringProperty(value: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalStringProperty(value: string, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required string. Please put a header 'headerParameter' =>
     * null and the client library should throw before the request is sent.
     *
     * @param {string} headerParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredStringHeader(headerParameter: string, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredStringHeader(headerParameter: string, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional string. Please put a header 'headerParameter' =>
     * null.
     *
     * @param {string} [bodyParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalStringHeader(bodyParameter: string, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalStringHeader(bodyParameter: string, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required complex object. Please put null and the client
     * library should throw before the request is sent.
     *
     * @param {object} bodyParameter
     * 
     * @param {number} [bodyParameter.id]
     * 
     * @param {string} [bodyParameter.name]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredClassParameter(bodyParameter: models.Product, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredClassParameter(bodyParameter: models.Product, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional complex object. Please put null.
     *
     * @param {object} [bodyParameter]
     * 
     * @param {number} [bodyParameter.id]
     * 
     * @param {string} [bodyParameter.name]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalClassParameter(bodyParameter: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalClassParameter(bodyParameter: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required complex object. Please put a valid class-wrapper
     * with 'value' = null and the client library should throw before the request
     * is sent.
     *
     * @param {object} value
     * 
     * @param {number} [value.id]
     * 
     * @param {string} [value.name]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredClassProperty(value: models.Product, options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredClassProperty(value: models.Product, callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional complex object. Please put a valid class-wrapper
     * with 'value' = null.
     *
     * @param {object} [value]
     * 
     * @param {number} [value.id]
     * 
     * @param {string} [value.name]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalClassProperty(value: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalClassProperty(value: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required array. Please put null and the client library
     * should throw before the request is sent.
     *
     * @param {array} bodyParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredArrayParameter(bodyParameter: string[], options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredArrayParameter(bodyParameter: string[], callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional array. Please put null.
     *
     * @param {array} [bodyParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalArrayParameter(bodyParameter: string[], options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalArrayParameter(bodyParameter: string[], callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required array. Please put a valid array-wrapper with
     * 'value' = null and the client library should throw before the request is
     * sent.
     *
     * @param {array} value
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredArrayProperty(value: string[], options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredArrayProperty(value: string[], callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional array. Please put a valid array-wrapper with
     * 'value' = null.
     *
     * @param {array} [value]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalArrayProperty(value: string[], options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalArrayProperty(value: string[], callback: ServiceCallback<void>): void;

    /**
     * Test explicitly required array. Please put a header 'headerParameter' =>
     * null and the client library should throw before the request is sent.
     *
     * @param {array} headerParameter
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postRequiredArrayHeader(headerParameter: string[], options: RequestOptions, callback: ServiceCallback<models.ErrorModel>): void;
    postRequiredArrayHeader(headerParameter: string[], callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Test explicitly optional integer. Please put a header 'headerParameter' =>
     * null.
     *
     * @param {array} [headerParameter]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postOptionalArrayHeader(headerParameter: string[], options: RequestOptions, callback: ServiceCallback<void>): void;
    postOptionalArrayHeader(headerParameter: string[], callback: ServiceCallback<void>): void;
}
